/* Ares2005 version 0.0.1
 Created by Stanisaw Paska <ares2005@o2.pl>
 * Release date: 20 Feb 2005
 *
 *
 * Copyright 2005-2100 Stanisaw Paska <ares2005@o2.pl>
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define MAX 1024
unsigned int los=1;/*zmienna do slosuj i losuj*/
/*procedura do ustalajca parametr dla losuj*/
extern void slosuj(unsigned int x)
{
 los=x;
}
/*funkcja losujca liczby cakowite*/
extern int losuj(void)
{
 los=los*1103515135+12345;
 return(unsigned int)(los/65536)%32768;
}
/*funkcja zwracajca rozmiar pliku w bajtach*/
long sizefile(char fn[300]) 
{
 long l;
 long m;
 FILE *pl;
 pl=fopen(fn,"rb");
 fseek(pl,0L,SEEK_SET);
 l=ftell(pl);
 fseek(pl,0L,SEEK_END);
 m=ftell(pl);
 return m-l;
}
/*procedura kodujca plik*/
int arescode(char fn[300],char fn1[300],char psswd[1024])
{
 static char ch[MAX];
 int i,l,k[5]={0};
 long roz,roz1;
 static char tp[1024];/*haso po I modyfikacji*/
 static char tp1[1024];/*haso po II modyfikacji*/
 FILE *pl,*pl1;/*Zmienne potrzebne do operacji na plikach*/
 roz=sizefile(fn);
 roz1=roz/MAX;
 pl=fopen(fn,"rb");
 pl1=fopen(fn1,"wb");
 /*tworzenie dodatkowych hase pomocniczych*/
 for (i=0;i<1024;i++)
 {
  tp[i]=(psswd[i]+psswd[i]*347-i*4937847)/(i+1);
  tp1[i]=(tp[i]*psswd[i]+i*tp[i]*psswd[i])/(i+1);
  k[0]=k[0]+tp1[i]*300*i;
  k[1]=k[1]+k[0]+tp[i]*300*i;
  k[2]=k[2]+k[1]^tp[i];
  k[3]=k[3]+k[1]*1103515135+12345;
  k[4]=k[4]+k[2]*1103515135+12345;
  psswd[i]=psswd[i]^tp[i]^tp1[i];
 }
 fwrite("STANISAW PASKA <ares2005@o2.pl> Warsaw POLAND",46,1,pl1);
/*haso zapisane do pliku wcelu weryfikacji prawdziwego hasa*/ 
  slosuj((k[0]+1)*(k[1]+1)*(k[2]+1)*(k[3]+1)*(k[4]+1));
  for (i=0;i<256;i++)
  {
   ch[i]=losuj()%256;
  }
 fwrite(ch,256,1,pl1);
 i=0;
 l=0;
 for (l=0;l<roz1;l++)
 {
  slosuj(k[l%5]+l);
  fread(ch,MAX,1,pl);
  for (i=0;i<MAX;i++)
  {
   ch[i]=ch[i]^psswd[i%1024]^(losuj()%256);
  }
  fwrite(ch,MAX,1,pl1);
  printf(" Wait : %d kb. \n",roz1-l);
 }
 roz1=roz-(roz1*MAX);
 fread(ch,roz1,1,pl);
 for (i=0;i<roz1;i++)
 {
  ch[i]=ch[i]^psswd[i%1024]^(losuj()%256);
 }
 fwrite(ch,roz1,1,pl1);
 fclose(pl1);
 fclose(pl);
 printf("File is coded. \a \n");
 return 0;
}
int aresdecode(char fn[300],char fn1[300],char psswd[1024])
{
 int i,k[5]={0},l;
 long roz,roz1;
 static char ch[1024];
 static char ch1[1024];
 static char tp[1024];
 static char tp1[1024];
 FILE *pl,*pl1;
 roz=sizefile(fn)-302;
 roz1=roz/MAX;
 pl=fopen(fn,"rb");
 pl1=fopen(fn1,"wb");
 fread(tp,46,1,pl);
 for (i=0;i<1024;i++)
 {
  tp[i]=(psswd[i]+psswd[i]*347-i*4937847)/(i+1);
  tp1[i]=(tp[i]*psswd[i]+i*tp[i]*psswd[i])/(i+1);
  k[0]=k[0]+tp1[i]*300*i;
  k[1]=k[1]+k[0]+tp[i]*300*i;
  k[2]=k[2]+k[1]^tp[i];
  k[3]=k[3]+k[1]*1103515135+12345;
  k[4]=k[4]+k[2]*1103515135+12345;
  psswd[i]=psswd[i]^tp[i]^tp1[i];
 }
 slosuj((k[0]+1)*(k[1]+1)*(k[2]+1)*(k[3]+1)*(k[4]+1));
 for (i=0;i<256;i++)
 {
  ch[i]=losuj()%256;
 }
 fread(ch1,256,1,pl);
 for (i=0;i<256;i++)
 {
  if (ch[i]!=ch1[i])
  {
   printf("BAD PASSWORD FILE TRY AGAIN !!!\n \a");
   fclose(pl1);
   remove(fn1);
   return 1;
  }
 }
 i=0;
 for (l=0;l<roz1;l++)
 {
  slosuj(k[l%5]+l); 
  fread(ch,MAX,1,pl);
  for (i=0;i<MAX;i++)
  {
   ch[i]=ch[i]^psswd[i%1024]^(losuj()%256);
  }
  fwrite(ch,MAX,1,pl1);
  printf(" Wait : %d kb.\n",roz1-l);
 }
 roz1=roz-(roz1*MAX);
 fread(ch,roz1,1,pl);
 for (i=0;i<roz1;i++)
 {
  ch[i]=ch[i]^psswd[i%1024]^(losuj()%256);
 }
 fwrite(ch,roz1,1,pl1);
 fclose(pl1);
 fclose(pl);
 printf("File is decoded. \n \a");
 return 0;
}
